#include <AutoItObject.au3>
#include <File.au3>
#include ".\objects\include_objects.au3"

_AutoItObject_Startup()
_Main()



Func _Main()
	Local $aList, $hGUI, $hListObjects, $hAddObjekt, $hEditObjekt, $nMsg
	Local $sObjektname

	$hGUI = GUICreate("Objektliste")
	$hListObjects = GUICtrlCreateList("", 0, 0, 400, 300)
	$hAddObjekt = GUICtrlCreateButton("Add Objekt", 0, 350, 200, 20)
	$hEditObjekt = GUICtrlCreateButton("Edit Objekt", 200, 350, 200, 20)
	GUISetState()


	; Liste der Objekte lesen
	$aList = _FileListToArray(@ScriptDir & '\objects\files\', '*.txt')
	For $i = 1 To UBound($aList) - 1
		GUICtrlSetData($hListObjects, StringTrimRight($aList[$i] , 4))
	Next


	While Sleep(10)
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case -3
				ExitLoop

			Case $hAddObjekt
				$sObjektname = InputBox("Objekt Name", "Bitte Objekt Namen eingeben")
				If @error Then ContinueLoop

				GUICtrlSetData($hListObjects, $sObjektname)
				_DetailScreen($hGUI, $sObjektname)

			Case $hEditObjekt
				$sObjektname = GUICtrlRead($hListObjects)
				_DetailScreen($hGUI, $sObjektname)

		EndSwitch
	WEnd

EndFunc   ;==>_Main

Func _DetailScreen($hMainGUI, $sObjektname)
	Local $hGUI, $hListProperty, $hListMethod, $hAddProperty, $hAddMethod, $nMsg
	Local $sMethodName, $sPropertyName, $sSourceCode, $hRunMethod, $hShowMethod

	GUISetState(@SW_DISABLE, $sObjektname)
	$hGUI = GUICreate("Objekt " & $sObjektname)
	GUICtrlCreateLabel("Properties:", 0, 0, 200, 20)
	$hListProperty = GUICtrlCreateList("", 0, 20, 200, 280)
	GUICtrlCreateLabel("Methods:", 200, 0, 200, 20)
	$hListMethod = GUICtrlCreateList("", 200, 20, 200, 280)

	$hAddProperty = GUICtrlCreateButton("Property hinzufügen", 0, 340, 200, 20)
	$hAddMethod = GUICtrlCreateButton("Methode hinzufügen", 200, 340, 200, 20)
	$hShowMethod = GUICtrlCreateButton("Methode anzeigen", 200, 360, 200, 20)
	$hRunMethod = GUICtrlCreateButton("Run Method", 200, 380, 200, 20)
	GUISetState()


	Local $aDef, $oObject, $sPropertyName, $sMethodName, $sFunctionName
	_FileReadToArray(@ScriptDir & '\objects\files\' & $sObjektname & '.txt', $aDef)

	For $i= 0 to UBound($aDef) -1
		Switch StringLeft($aDef[$i],2)
			Case 'a:'
				$sPropertyName = StringTrimLeft($aDef[$i],2)
				GUICtrlSetData($hListProperty, $sPropertyName)

			Case 'm:'
				$sMethodName = StringTrimLeft($aDef[$i],2)
				GUICtrlSetData($hListMethod, $sMethodName)
		EndSwitch
	Next






	While Sleep(10)
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case -3
				ExitLoop

			Case $hShowMethod
				_ShowSourceCode($hGUI, $sObjektname, $sMethodName)
				If $sSourceCode = "" Then ContinueLoop

			Case $hAddMethod
				$sMethodName = InputBox("Method Name", "Bitte Method Namen eingeben")
				If @error Then ContinueLoop

				GUICtrlSetData($hListMethod, $sMethodName)

				$sSourceCode = _EnterSourceCode($hGUI, $sMethodName)
				If $sSourceCode = "" Then ContinueLoop

				_NewMethodIntoFile($sObjektname, $sMethodName, $sSourceCode)

			Case $hAddProperty
				$sPropertyName = InputBox("Property Name", "Bitte Property Namen eingeben")
				If @error Then ContinueLoop

				GUICtrlSetData($hListProperty, $sPropertyName)

				_NewPropertyIntoFile($sObjektname, $sPropertyName)


			Case $hRunMethod
				$sMethodName = GUICtrlRead($hListMethod)
				Local $oObject = _BuildObject($sObjektname)

				Execute("$oObject." & $sMethodName & "()")
		EndSwitch
	WEnd

	GUIDelete($hGUI)

	GUISwitch($hMainGUI)
	GUISetState(@SW_ENABLE)
	WinActivate($hMainGUI)
EndFunc   ;==>_DetailScreen

Func _EnterSourceCode($hMainGUI, $sMethodName)
	Local $hGUI, $hEdit, $sSourceCode

	GUISetState(@SW_DISABLE, $hMainGUI)
	$hGUI = GUICreate("Sourcecode eingeben für " & $sMethodName)
	$hEdit = GUICtrlCreateEdit("", 0, 0, 400, 400)
	GUISetState()

	While GUIGetMsg() <> -3
		Sleep(10)
	WEnd

	$sSourceCode = GUICtrlRead($hEdit)
	GUIDelete($hGUI)

	GUISwitch($hMainGUI)
	GUISetState(@SW_ENABLE)
	WinActivate($hMainGUI)

	Return $sSourceCode
EndFunc   ;==>_EnterSourceCode

Func _ShowSourceCode($hMainGUI, $sObjektname, $sMethodName)
	Local $hGUI, $hEdit, $sSourceCode, $aFile

	GUISetState(@SW_DISABLE, $hMainGUI)
	$hGUI = GUICreate("Sourcecode anzeigen für " & $sMethodName)
	$hEdit = GUICtrlCreateEdit("", 0, 0, 400, 400)
	GUISetState()
	GUICtrlSetState($hEdit, 128)


	_FileReadToArray(@ScriptDir & '\objects\files\' & $sObjektname & '__' & $sMethodName &'.au3', $aFile)
	For $i = 2 to UBound($aFile) - 2
		$sSourceCode &= $aFile[$i] & @CRLF
	Next
	GUICtrlSetData($hEdit, $sSourceCode)

	While GUIGetMsg() <> -3
		Sleep(10)
	WEnd

	GUIDelete($hGUI)

	GUISwitch($hMainGUI)
	GUISetState(@SW_ENABLE)
	WinActivate($hMainGUI)
EndFunc   ;==>_ShowSourceCode


Func _NewPropertyIntoFile($sObjektname, $sPropertyName)
	FileWrite(@ScriptDir & '\objects\files\' & $sObjektname & '.txt', _
			'a:' & $sPropertyName & @CRLF)
EndFunc   ;==>_NewPropertyIntoFile

Func _NewMethodIntoFile($sObjektname, $sMethodName, $sSourceCode)
	FileWrite(@ScriptDir & '\objects\files\' & $sObjektname & '.txt', _
			'm:' & $sMethodName & @CRLF)


	$sSourceCode = '' & _
			'Func __' & $sObjektname & '__' & $sMethodName & '($oSelf)' & @CRLF & _
			$sSourceCode & @CRLF & _
			'EndFunc' & @CRLF


	FileWrite(@ScriptDir & '\objects\files\' & $sObjektname & '__' & $sMethodName &'.au3', $sSourceCode)
	FileWrite(@ScriptDir & '\objects\include_objects.au3', '#include ".\files\' & $sObjektname & '__' & $sMethodName &'.au3"' & @CRLF)
EndFunc   ;==>_NewMethodIntoFile


Func _BuildObject($sObjektname)
	Local $aDef, $oObject, $sPropertyName, $sMethodName, $sFunctionName
	_FileReadToArray(@ScriptDir & '\objects\files\' & $sObjektname & '.txt', $aDef)
	$oObject = _AutoItObject_Create()

	For $i= 0 to UBound($aDef) -1
		Switch StringLeft($aDef[$i],2)
			Case 'a:'
				$sPropertyName = StringTrimLeft($aDef[$i],2)
				_AutoItObject_AddProperty($oObject, $sPropertyName)
			Case 'm:'
				$sMethodName = StringTrimLeft($aDef[$i],2)
				$sFunctionName = '__' & $sObjektname & '__' & $sMethodName
				_AutoItObject_AddMethod($oObject, $sMethodName, $sFunctionName)
		EndSwitch
	Next

	Return $oObject
EndFunc   ;==>_Builder_BuildObject



